;
;
;
;    Resea (api/assembly.asm)
;    Mafice <mafice@mflabo.net>
;
;
;

[bits 64]


API_putchar        equ  901
API_out            equ  111
API_in             equ  121
API_setISR         equ  201
API_waitInterrupt  equ  202


;
;  Function: asm_putchar
;
;    一文字表示する
;
;  Parameters:
;
;    ch -  表示する文字
;
;  Returns:
;
;    なし
;
;

global asm_putchar
asm_putchar:

mov rax, API_putchar
;mov rdi, rdi

int 0x70
ret




;
;  Function: asm_out8
;
;    OUT命令を実行する
;
;  Parameters:
;
;    dest -  送信先
;    data -  データ
;
;  Returns:
;
;    なし
;
;

global asm_out8
asm_out8:

mov rax, API_out
mov rdi, rdi
mov rbx, rsi
mov rcx, 8

int 0x70
ret




;
;  Function: asm_in8
;
;    IN命令を実行する
;
;  Parameters:
;
;    src -  受信元
;
;  Returns:
;
;    受信したデータ
;
;

global asm_in8
asm_in8:

mov rax, API_in
mov rsi, rdi
mov rcx, 8

int 0x70
ret




;
;  Function: asm_waitInterrupt
;
;    割り込みを待つ
;
;  Parameters:
;
;    irq -  割り込み要求の番号
;
;  Returns:
;
;    なし
;
;

global asm_waitInterrupt
asm_waitInterrupt:

mov rax, API_waitInterrupt
mov rsi, rdi

int 0x70
ret




;
;  Function: asm_setISR
;
;    割り込みハンドラを登録する
;
;  Parameters:
;
;    irq    -  割り込み要求の番号
;    offset -  ハンドラの先頭アドレス
;
;  Returns:
;
;    登録に成功した場合はtrue、失敗した場合はfalseを返します。
;
;

global asm_setISR
asm_setISR:

mov rax, API_setISR
mov rdx, rsi
mov rsi, rdi

int 0x70
ret


